<?php

if ( !class_exists( 'yank_widget_core' ) ) {

    class yank_widget_core { 
		
        function yank_widget_core() { // Maintain php4 compatiblity  
        	global $wpdb;

			$this->nice_name = 'yank_widget';
			$this->nice_system_name = 'yank-widget';
			
			$this->options = array(
        		'db_version' => '1.0',
        		'db_table' => $wpdb->prefix . $this->nice_name,
        		'widget_limit' => 9,
        		'user_level' => 10
        	);

        	$this->db_table = $this->options['db_table'];
        	
        	$this->page_excludes = array();
        	$this->widgets = array();
        	
			$this->core_path = ABSPATH . "wp-content/plugins/$this->nice_system_name/";
        	$this->core_uri = get_bloginfo('wpurl') . "/wp-content/plugins/$this->nice_system_name/";
     
        	$this->is_installed = $this->is_db_installed();
        	
        	if ( !$this->is_installed ) return;
        	
        	$this->page_excludes = get_option( $this->nice_name . '_excludes' );
        	$this->widgets = get_option( $this->nice_name . '_widgets' );
        	$this->options = get_option( $this->nice_name . '_options' );
        	
        }

        function is_db_installed() {
        	global $wpdb;
        	if( $wpdb->get_var( "SHOW TABLES LIKE '$this->db_table'") == $this->db_table ) return true;
			return false;
        }
        
		/**
		* Filter excluded pages from wp_list_pages
		*
		* Function used as filter to add noted pages to be excluded from page listings.
		*
		*/
		function exclude_pages( $excludes ) {
							
			if ( !is_array( $this->page_excludes ) ) return $excludes;
			if ( !is_array( $excludes ) ) $excludes = array();
		
			foreach ( $this->page_excludes as $yank_exclude ) {
				if ( !in_array( $yank_exclude, $excludes ) ) array_push( $excludes, $yank_exclude );
			}
		
			return $excludes;
		}        
        
	}
	
}

?>